config/routes.rb
Rails.application.routes.draw do

  root 'car_rental#home'
  get 'sessions/new'
  get 'users/new'
  get '/help', to: 'car_rental#help'
  get '/about', to:'car_rental#about'
  get  '/signup',  to: 'users#new'
  post '/signup',  to: 'users#create'

  get  '/new_user',  to: 'users#newuser'
  post '/new_user',  to: 'users#createuser'

  get  '/new_admin',  to: 'users#newadmin'
  get  '/edit',  to: 'users#edit'
  post '/new_admin',  to: 'users#createadmin'

  get  '/new_superadmin',  to: 'users#newsuperadmin'
  post '/new_superadmin',  to: 'users#createsuperadmin'


  get  '/cars',  to: 'cars#index'
  post '/cars',  to: 'cars#create'

  get    '/login',   to: 'sessions#new'
  post   '/login',   to: 'sessions#create'
  delete '/logout',  to: 'sessions#destroy'
  get 'show_admin', to: 'users#show_admin', as: :show_admin, via: :all
  match '/users/newadmin', to: 'users#newadmin', as: :newadmin, via: :all

  get 'show_superadmin', to: 'users#show_superadmin', as: :show_superadmin, via: :all
  match '/users/newsuperadmin', to: 'users#newsuperadmin', as: :newsuperadmin, via: :all

  get '/bookings/:id/check_out', to: 'bookings#check_out', as: :check_out
  get '/bookings/:id/return', to: 'bookings#return', as: :return

  get 'email_notification/:id/:id1' => 'cars#email_notification' ,:as => 'email_notification'

  #match '/users/newuser', to: 'users#newuser', as: :new_user, via: :all
  resources :bookings
  #resources :users

  resources :users do
    resources :bookings
  end


  resources :cars do
    resources :bookings
  end

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  #root 'users#index'
end

app/models/booking.rb
class Booking < ApplicationRecord
  belongs_to :car
  belongs_to :user

  validates :start_time, :presence => true
  validates :end_time, :presence => true


  validates :booking_duration_check, inclusion: { in: 1..10, message: 'Please choose between 1 hour and 10 hours' }
  validate :date_range, on: :create
  validate :date_range_edit, on: :update

  def booking_duration_check
    if start_time == nil or end_time == nil
      errors.add(:base, 'Dates can not be empty')
    else
      ( Time.parse(end_time.to_s) - Time.parse(start_time.to_s) ) / 3600
    end
  end


  def date_range_edit
    if start_time != nil and end_time != nil
      unless start_time - Time.now <= 7
        errors.add(:base, 'Booking can not be done more than 7 days in advance')
      end
      unless start_time - Time.now <= 0
        errors.add(:base, 'Booking can not be done more than 7 days in advance')
      end
      unless Booking.where('car_id = ?  AND status <2 AND id <> ? AND ((start_time <= ? AND end_time >= ?) OR (start_time >= ? AND end_time <= ?) OR (start_time <= ? AND end_time >= ?))',
                           car_id, id, start_time, start_time,
                           start_time, end_time, end_time, end_time).empty?
        errors.add(:base, 'Car is unavailable, choose other dates')
      end
    end
  end

  def date_range
    if start_time != nil and end_time != nil
      unless start_time - Time.now <= 7
        errors.add(:base, 'Booking can not be done more than 7 days in advance')
      end
      unless start_time - Time.now <= 0
        errors.add(:base, 'Booking can not be done more than 7 days in advance')
      end
      unless Booking.where('car_id = ?  AND status <2 AND id <> ? AND ((start_time <= ? AND end_time >= ?) OR (start_time >= ? AND end_time <= ?) OR (start_time <= ? AND end_time >= ?))',
                           car_id, id, start_time, start_time,
                           start_time, end_time, end_time, end_time).empty?
        errors.add(:base, 'Car is unavailable, choose other dates')
      end
    end
  end


end

app/controllers/bookings_controller.rb
class BookingsController < ApplicationController
  before_action :logged_in_user, only: [:index, :edit, :update, :destroy]
  before_action :set_car
  before_action :set_user
  before_action :set_users
  before_action :set_booking, only: [:show, :edit, :update, :destroy]


  # GET /bookings
  # GET /bookings.json
  def index
    #puts current_user.id
    if(current_user.user_type == 2)
      @bookings = Booking.where("user_id = ?", current_user.id)
    else
      if(@user == nil and @car == nil)
        @bookings = Booking.all
      elsif(@car == nil)
        @bookings = Booking.where("user_id = ?", @user.id)
      else
        @bookings = Booking.where("car_id = ?", @car.id)
      end

      #@bookings = Booking.all
    end
  end

  # GET /bookings/1
  # GET /bookings/1.json
  def show
  end

  # GET /bookings/new
  def new
    @booking = Booking.new
    @users= User.where(user_type: 2).all
  end

  # GET /bookings/1/edit
  def edit
  end

  # POST /bookings
  # POST /bookings.json
  def create
    @booking = Booking.new(booking_params)
    @booking.car_id = @car.id
    if current_user.user_type == 2
      @booking.user_id = current_user.id
    end
    @booking.status = 0
    respond_to do |format|
      if @booking.save then
        @car.status = 'Reserved'
        @car.save
        if current_user.user_type == 2
          format.html { redirect_to current_user, notice: 'Booking was successfully created' }
        else
          format.html { redirect_to cars_path(), notice: 'Booking was successfully created' }
        end

        format.json { render action: 'show', status: :created, location: @booking }
      else
        flash[:notice] = @msg
        format.html { render action: 'new' }
        format.json { render json: @booking.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /bookings/1
  # PATCH/PUT /bookings/1.json
  def update
    respond_to do |format|
      if @booking.update(booking_params)
        format.html { redirect_to current_user, notice: 'Booking was successfully updated.' }
        format.json { render :show, status: :ok, location: @booking }
      else
        format.html { render :edit }
        format.json { render json: @booking.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /bookings/1
  # DELETE /bookings/1.json
  def destroy
    @car = Car.find(@booking.car_id)
    @booking.destroy
    @car.status = 'Available'
    @car.save
    if @car.email_register and !@car.user.empty?
      user = User.find_by_email(@car.user)
      ApplicationMailer.car_available_email_notification(user).deliver_now
      @car.user = nil
      @car.email_register = false
      @car.save!
    end
    respond_to do |format|
      format.html { redirect_to bookings_url, notice: 'Booking was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  def check_out
    @booking = Booking.find(params[:id])
    @booking.status = 1
    respond_to do |format|
      if @booking.save then
        @car = Car.find(@booking.car_id)
        @car.status = 'Checked Out'
        @car.save
        format.html { redirect_to bookings_url, notice: 'Car checked out successfully' }
      else
        format.html { redirect_to bookings_url, notice: 'Something went wrong, please try again' }
      end
    end
  end

  def return
    @booking = Booking.find(params[:id])
    @car = Car.find(@booking.car_id)
    @booking.status = 2
    if @car.email_register and !@car.user.empty?
      user = User.find_by_email(@car.user)
      ApplicationMailer.car_available_email_notification(user).deliver_now
      @car.user = nil
      @car.email_register = false
      @car.save!
    end
    respond_to do |format|
      if @booking.save then
        @car = Car.find(@booking.car_id)
        @car.status = 'Available'
        @car.save



        format.html { redirect_to bookings_url, notice: 'Car Returned successfully' }
      else
        format.html { redirect_to bookings_url, notice: 'Something went wrong, please try again' }
      end
    end
  end


  def logged_in_user
    unless logged_in?
      store_location
      flash[:danger] = "Please log in."
      redirect_to login_url
    end
  end

  def set_car
    if(params[:car_id] != nil)
      @car = Car.find(params[:car_id])
    end
  end

  def set_user
    if(params[:user_id] != nil)
      @user = User.find(params[:user_id])
    end
  end

  def set_booking
    #puts params[:id]
    @booking = Booking.find(params[:id])
  end

  def type(val)
    if(val == 0)
      return 'Reserved'
    elsif(val == 1)
      return 'Checked Out'
    else
      return 'Returned'
    end
  end
  helper_method :type

  private
  def booking_params
    params.require(:booking).permit(:start_time, :end_time, :user_id)
  end
  def set_users
    @users= User.where(user_type: 2).all
  end
end

app/helpers/bookings_helper.rb
module BookingsHelper
end

app/views/bookings/_form.html.erb
<%= form_for [@car, @booking] do |f| %>
    <% if @booking.errors.any? %>
        <div id="error_explanation">
          <h2><%= pluralize(@booking.errors.count, "error") %> prohibited this booking from being saved:</h2>

          <ul>
            <% @booking.errors.full_messages.each do |msg| %>
                <li><%= msg %></li>
            <% end %>
          </ul>
        </div>
    <% end %>
    <div class='field'>
      <%= f.label :start_time %><br>
      <%= f.datetime_local_field :start_time, class: "form-control" %>
    </div>
    <br />
    <div class='field'>
      <%= f.label :end_time %><br>
      <%= f.datetime_field :end_time, class: "form-control" %>
    </div>
    <br />
    <div class="actions">
      <%= f.submit %>
    </div>
<% end %>

app/views/bookings/edit.html.erb
<h1>Editing Booking</h1>

<%= render 'form', booking: @booking %>

<%= link_to 'Show', @booking %> |
<%= link_to 'Back', current_user %>

app/views/bookings/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Bookings</h1>

<table class="table">
  <thead>
  <tr>
    <th>From</th>
    <th>To</th>
    <th>Car</th>
    <% if current_user.user_type.in?([0, 1]) %>
        <th>Customer Email</th>
        <th>Status</th>
    <% end %>

    <th colspan="3"></th>
  </tr>
  </thead>

  <tbody>
  <% @bookings.each do |booking| %>
      <tr>
        <td><%= booking.start_time %></td>
        <td><%= booking.end_time %></td>
        <td><%= Car.find_by_id(booking.car_id).model %></td>
        <% if current_user.user_type.in?([0, 1]) %>
            <td><%= User.find_by_id(booking.user_id).email %></td>
            <td><%= type(booking.status) %></td>
        <% end %>
        <% if booking.status == 0 %>
            <td><%= link_to 'Edit', edit_booking_path(booking) %></td>
        <% end %>
        <td>
          <% if booking.status == 0 %>
              <%= link_to 'Cancel Booking', [booking], method: :delete, data: { confirm: 'Are you sure?' } %>
              <%= link_to "Check Out", check_out_url(booking.id) %>
          <% elsif booking.status == 1 %>
              <%= link_to "Return", return_url(booking.id) %>
          <% end %>
        </td>
      </tr>
  <% end %>
  </tbody>
</table>
<br>

app/views/bookings/new.html.erb
<h1>Book Car</h1>
<h4>Model: <%= @car.model %></h4>
<h4>Manufacturer: <%= @car.manufacturer %></h4>
<h4>Style: <%= @car.style %></h4>
<h4>Rate per hour ($): <%= @car.price %></h4>
<h4>Location: <%= @car.location %></h4><br>

<%= form_for [@car, @booking] do |f| %>
    <% if @booking.errors.any? %>
        <div id="error_explanation">
          <h2><%= pluralize(@booking.errors.count, "error") %> prohibited this booking from being saved:</h2>

          <ul>
            <% @booking.errors.full_messages.each do |msg| %>
                <li><%= msg %></li>
            <% end %>
          </ul>
        </div>
    <% end %>
    <% if current_user.user_type.in?([0, 1]) %>
        <div class='field'>
          <%= f.label :select_user %>
          <%= f.collection_select :user_id, @users, :id, :email %>
        </div>
    <% end %>

    <div class='field'>
      <%= f.label :start_time %>
      <%= f.datetime_local_field :start_time, class: "form-control" %>
    </div>
    <br />
    <div class='field'>
      <%= f.label :end_time %>
      <%= f.datetime_field :end_time, class: "form-control" %>
    </div>
    <br />
    <div class="actions">
      <%= f.submit %>
    </div>
<% end %>

app/views/bookings/show.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'Edit', edit_booking_path(@booking) %> |
<%= link_to 'Back', bookings_path %>